# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_identity_lib.api_client import ApiClient


class OrganizationControllerApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_by_id(self, org_id, **kwargs):  # noqa: E501
        """Read an organization.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_by_id(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_by_id_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_by_id_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_by_id_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Read an organization.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_by_id_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_org_roles(self, org_id, **kwargs):  # noqa: E501
        """Get Organization Roles  # noqa: E501

        Get list of organization roles. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_org_roles(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: Unique identifier (GUID) of the organization. (required)
        :param str name: Role name (or comma separated list of role names
        :param bool expand: Indicates if response should be expanded, value is ignored - only existence of parameter is checked
        :return: InlineResponse2009
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_org_roles_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_org_roles_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_org_roles_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get Organization Roles  # noqa: E501

        Get list of organization roles. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_org_roles_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: Unique identifier (GUID) of the organization. (required)
        :param str name: Role name (or comma separated list of role names
        :param bool expand: Indicates if response should be expanded, value is ignored - only existence of parameter is checked
        :return: InlineResponse2009
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'name', 'expand']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_org_roles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_org_roles`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []
        if 'name' in params:
            query_params.append(('name', params['name']))  # noqa: E501
        if 'expand' in params:
            query_params.append(('expand', params['expand']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/roles', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2009',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_org_sub_orgs(self, org_id, **kwargs):  # noqa: E501
        """Get all organization's sub-orgs.  # noqa: E501

        Returns all sub organizations for the passed Org ID. The user needs to be either organization owner or a platform operator in order to get a result. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_org_sub_orgs(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse20025
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_org_sub_orgs_with_http_info(org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_org_sub_orgs_with_http_info(org_id, **kwargs)  # noqa: E501
            return data

    def get_org_sub_orgs_with_http_info(self, org_id, **kwargs):  # noqa: E501
        """Get all organization's sub-orgs.  # noqa: E501

        Returns all sub organizations for the passed Org ID. The user needs to be either organization owner or a platform operator in order to get a result. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_org_sub_orgs_with_http_info(org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :return: InlineResponse20025
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_org_sub_orgs" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_org_sub_orgs`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/sub-orgs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20025',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_role_by_org_id_and_role_id(self, org_id, role_id, **kwargs):  # noqa: E501
        """Read a role.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_role_by_org_id_and_role_id(org_id, role_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str role_id: (required)
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_role_by_org_id_and_role_id_with_http_info(org_id, role_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_role_by_org_id_and_role_id_with_http_info(org_id, role_id, **kwargs)  # noqa: E501
            return data

    def get_role_by_org_id_and_role_id_with_http_info(self, org_id, role_id, **kwargs):  # noqa: E501
        """Read a role.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_role_by_org_id_and_role_id_with_http_info(org_id, role_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str role_id: (required)
        :return: InlineResponse2006
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'role_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_role_by_org_id_and_role_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `get_role_by_org_id_and_role_id`")  # noqa: E501
        # verify the required parameter 'role_id' is set
        if ('role_id' not in params or
                params['role_id'] is None):
            raise ValueError("Missing the required parameter `role_id` when calling `get_role_by_org_id_and_role_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501
        if 'role_id' in params:
            path_params['roleId'] = params['role_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/roles/{roleId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2006',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_org(self, body, org_id, **kwargs):  # noqa: E501
        """Update organization details.  # noqa: E501

        NOTE: At the moment we only allow for displayName change. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_org(body, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgsOrgIdBody body: (required)
        :param str org_id: (required)
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_org_with_http_info(body, org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_org_with_http_info(body, org_id, **kwargs)  # noqa: E501
            return data

    def patch_org_with_http_info(self, body, org_id, **kwargs):  # noqa: E501
        """Update organization details.  # noqa: E501

        NOTE: At the moment we only allow for displayName change. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_org_with_http_info(body, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgsOrgIdBody body: (required)
        :param str org_id: (required)
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_org" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_org`")  # noqa: E501
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `patch_org`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2008',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def patch_org_roles(self, body, org_id, **kwargs):  # noqa: E501
        """Edit roles.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_org_roles(body, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgIdRolesBody2 body: (required)
        :param str org_id: (required)
        :return: InlineResponse20010
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.patch_org_roles_with_http_info(body, org_id, **kwargs)  # noqa: E501
        else:
            (data) = self.patch_org_roles_with_http_info(body, org_id, **kwargs)  # noqa: E501
            return data

    def patch_org_roles_with_http_info(self, body, org_id, **kwargs):  # noqa: E501
        """Edit roles.  # noqa: E501

        ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x2714;&#xFE0F; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x0274c; | | Service Account (Whitelisted Client) | &#x0274c; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.patch_org_roles_with_http_info(body, org_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrgIdRolesBody2 body: (required)
        :param str org_id: (required)
        :return: InlineResponse20010
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'org_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch_org_roles" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `patch_org_roles`")  # noqa: E501
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `patch_org_roles`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/roles', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20010',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def search_org_groups(self, org_id, group_search_term, **kwargs):  # noqa: E501
        """Find groups.  # noqa: E501

        Performs a search for groups in the organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x0274c; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_org_groups(org_id, group_search_term, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str group_search_term: (required)
        :return: InlineResponse20031
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.search_org_groups_with_http_info(org_id, group_search_term, **kwargs)  # noqa: E501
        else:
            (data) = self.search_org_groups_with_http_info(org_id, group_search_term, **kwargs)  # noqa: E501
            return data

    def search_org_groups_with_http_info(self, org_id, group_search_term, **kwargs):  # noqa: E501
        """Find groups.  # noqa: E501

        Performs a search for groups in the organization. ### Access Policy | Role | Access | | ----- | ----- | | Platform operator | &#x0274c; | | Organization Owner | &#x2714;&#xFE0F; | | Organization Member | &#x2714;&#xFE0F; | | Service Account (Whitelisted Client) | &#x2714;&#xFE0F; |   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_org_groups_with_http_info(org_id, group_search_term, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str org_id: (required)
        :param str group_search_term: (required)
        :return: InlineResponse20031
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['org_id', 'group_search_term']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_org_groups" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_id' is set
        if ('org_id' not in params or
                params['org_id'] is None):
            raise ValueError("Missing the required parameter `org_id` when calling `search_org_groups`")  # noqa: E501
        # verify the required parameter 'group_search_term' is set
        if ('group_search_term' not in params or
                params['group_search_term'] is None):
            raise ValueError("Missing the required parameter `group_search_term` when calling `search_org_groups`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_id' in params:
            path_params['orgId'] = params['org_id']  # noqa: E501

        query_params = []
        if 'group_search_term' in params:
            query_params.append(('groupSearchTerm', params['group_search_term']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/csp/gateway/am/api/orgs/{orgId}/groups-search', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20031',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
